0%

『LeetCode』剑指 Offer II 091 粉刷房子

题目

剑指 Offer II 091. 粉刷房子

假如有一排房子,共 n 个,每个房子可以被粉刷成红色、蓝色或者绿色这三种颜色中的一种,你需要粉刷所有的房子并且使其相邻的两个房子颜色不能相同。

当然,因为市场上不同颜色油漆的价格不同,所以房子粉刷成不同颜色的花费成本也是不同的。每个房子粉刷成不同颜色的花费是以一个 n x 3的正整数矩阵 costs 来表示的。

例如,costs[0][0] 表示第 0 号房子粉刷成红色的成本花费;costs[1][2] 表示第 1 号房子粉刷成绿色的花费,以此类推。

请计算出粉刷完所有房子最少的花费成本。

示例 1:

输入: costs = [[17,2,17],[16,16,5],[14,3,19]]
输出: 10
解释: 将 0 号房子粉刷成蓝色,1 号房子粉刷成绿色,2 号房子粉刷成蓝色。
最少花费: 2 + 5 + 3 = 10。

示例 2:

输入: costs = [[7,6,2]]
输出: 2

提示:

  • costs.length == n
  • costs[i].length == 3
  • 1 <= n <= 100
  • 1 <= costs[i][j] <= 20

注意:本题与主站 256 题相同:https://leetcode-cn.com/problems/paint-house/(是会员题)

标签

数组, 动态规划


题解

【粉刷房子】简单动态规划

动态规划

不难发现,第 \(i\) 间房子刷成什么颜色取决于第 \(i - 1\) 间房子的颜色,设第 \(i\) 间房子粉刷成 \(\text{color}\) 的最小成本为 \(\text{dp}_{\text{color}}[i]\), 即:

\[ \begin{cases} \text{dp}_{\text{r}}[i] &= \text{cost}_{\text{r}}[i] + \min (\text{dp}_{\text{g}}[i - 1] , \text{dp}_{\text{b}}[i - 1]) \\ \text{dp}_{\text{g}}[i] &= \text{cost}_{\text{g}}[i] + \min (\text{dp}_{\text{r}}[i - 1] , \text{dp}_{\text{b}}[i - 1]) \\ \text{dp}_{\text{b}}[i] &= \text{cost}_{\text{b}}[i] + \min (\text{dp}_{\text{r}}[i - 1] , \text{dp}_{\text{g}}[i - 1]) \\ \end{cases} \]

由于 \(\text{dp}[i]\) 仅由 \(\text{dp}[i - 1]\) 得到,所以可以使用滚动数组进行优化,而无需 \(O(n)\) 的数组。

1
2
3
4
5
6
7
8
9
10
11
# Code language: Python
class Solution:
def minCost(self, costs: List[List[int]]) -> int:
# 第 i 间房子刷成 r, g, b 颜色的最小花费成本
cost_r, cost_g, cost_b = 0, 0, 0
for r, g, b in costs:
cr = r + min(cost_g, cost_b)
cg = g + min(cost_r, cost_b)
cb = b + min(cost_r, cost_g)
cost_r, cost_g, cost_b = cr, cg, cb
return min(cost_r, cost_g, cost_b)
1
2
3
4
5
6
7
8
9
10
11
12
13
// Code language: Java
class Solution {
public int minCost(int[][] costs) {
int r = 0, g = 0, b = 0;
for (int[] cost: costs) {
int cr = cost[0] + Math.min(g, b);
int cg = cost[1] + Math.min(r, b);
int cb = cost[2] + Math.min(r, g);
r = cr; g = cg; b = cb;
}
return Math.min(r, Math.min(g, b));
}
}
1
2
3
4
5
6
7
8
9
10
11
12
13
14
// Code language: C++
class Solution {
public:
int minCost(vector<vector<int>>& costs) {
int r = 0, g = 0, b = 0;
for (vector<int>& cost: costs) {
int cr = cost[0] + min(g, b);
int cg = cost[1] + min(r, b);
int cb = cost[2] + min(r, g);
r = cr; g = cg; b = cb;
}
return min(r, min(g, b));
}
};
  • 时间复杂度: \(O(n)\)
  • 空间复杂度: \(O(1)\)

记忆化搜索

也可以用记忆化搜索, 思路和动态规划基本一样。

1
2
3
4
5
6
7
8
9
# Code language: Python
class Solution:
def minCost(self, costs: List[List[int]]) -> int:

@cache
def dfs(idx, color):
return (costs[idx][color] + min(dfs(idx - 1, c) for c in range(3) if c != color)) if idx > 0 else costs[0][color]

return min(dfs(len(costs) - 1, c) for c in range(3))
  • 时间复杂度: \(O(n)\)
  • 空间复杂度: \(O(n)\)

如果对你有帮助的话,请给我点个赞吧~

欢迎前往 我的博客Algorithm - Github 查看更多题解

--- ♥ end ♥ ---

欢迎关注我呀~